<?php
/**
 * Youdian Content Management System
 * Copyright (C) YoudianSoft Co.,Ltd (http://www.youdiancms.com). All rights reserved.
 */
class DecorationAction extends AdminBaseAction{
	//模板装修首页
	function index(){
        header("Content-Type:text/html; charset=utf-8");
        $m = D('Admin/Member');
        $MemberID = session('AdminMemberID');
        $MemberAvatar = $m->getMemberAvatar($MemberID);
        $this->assign('MemberAvatar', $MemberAvatar);
        $this->assign('ConfigContentUrl', __URL__.'/getConfigContent');
        $this->assign('SaveConfigAction', __URL__.'/saveConfig');
        $this->assign('SaveContentAction', __URL__.'/saveContent');

        $this->assign('SaveCodeAction', __URL__.'/saveCode');
        $this->assign('GetCodeAction', __URL__.'/getCode');

        $this->assign('OrderComponentAction', __URL__.'/orderComponent');
        $this->assign('GetComponentAction', __URL__.'/getComponent');
        $this->assign('AddComponentAction', __URL__.'/addComponent');
        $this->assign('DeleteComponentAction', __URL__.'/deleteComponent');
        //检查是否启用装修=====================================
        $m = D('Admin/Config');
        $data = $m->getConfig('other'); //配置数据不从缓存中提取
        $this->assign('EnableDecoration', $data['EnableDecoration'] );
        $this->assign('DecorationKey', $data['DecorationKey'] );
        //===============================================
		$this->display();
	}

	/*
	 * 获取配置内容
	 */
	function getConfigContent(){
        header("Content-Type:text/html; charset=utf-8");
        $GroupID = intval($_GET['GroupID']);
        if(empty($GroupID)){
            $this->ajaxReturn(null, '分组ID不存在!' , 0);
        }
        $tc = $this->getTemplateConfigInstance();
        $params = array();
        $params['GroupID'] = $GroupID;
        $params['ShowVarNameInHelp'] = false; //是否显示变量名称
        $attributes = $tc->getAttribute($params);
        $html = $this->_getAttributeHtml($attributes);
        $data = array('Html'=>$html, 'Count'=>count($attributes));
        $this->ajaxReturn($data, '' , 1);
    }

    /**
     * 获取属性HTML
     */
    private function _getAttributeHtml($attributes){
	    $html = '';
        $class = "";
        $tabs = array();
        $tabIndex = 0;
        $style = '';
        foreach($attributes as $v){
            if(!empty($v['Tab'])){
                $tabName = $v['Tab'];
                $class = 'tr'.yd_pinyin($tabName,false);
                $tabs[] = array('TabName'=>$tabName, 'TabID'=>$class);
                $class = " class=\"trtab {$class}\"";
                $tabIndex++;
            }
            if($tabIndex > 1){
                $style = "style='display:none;'";
            }
            $temp = str_ireplace('__URL__', __URL__, $v['html']);
            $html .= "<tr {$class} {$style}>";
            if('animation'==$v['DisplayType'] || 'list'==$v['DisplayType'] || $v['FieldName']=='TCustomStyle'
                || 'table'==$v['DisplayType'] ){ //动画不显示头th
                $html .= "<td colspan='2'>{$temp}</td>";
            }else{
                $html .= "<th>{$v['DisplayName']}</th><td>{$temp}</td>";
            }
            $html .= "</tr>";
        }

        if(!empty($tabs)){
            $tabHtml = '<tr class="tabbar"><td colspan="2">';
            $tabHtml .= '<span class="tabwrap">';
            foreach($tabs as $k=>$v){
                $current = ($k==0) ? 'current' : '';
                $tabHtml .= "<span class='tab-item {$current}' onclick='changeTab(this, \"{$v['TabID']}\")'>{$v['TabName']}</span>";
            }
            $tabHtml .= '</span></td></tr>';
            $html = "{$tabHtml}{$html}";
        }
        return $html;
    }

    /*
     * 保存样式设置
     */
    function saveConfig(){
        header("Content-Type:text/html; charset=utf-8");
        $tc = $this->getTemplateConfigInstance();
        $b = $tc->save($_POST);
        if($b === false){
            $this->ajaxReturn(null, '操作失败!' , 0);
        }else{
            if(!APP_DEBUG) YdCache::deleteHome();
            $data = array();
            //$allHtml = yd_curl_get('http://cms9.a.com/index.php', array('random'=>time()));
            /* $n = preg_match("/<body[^>]*?>(.*\s*?)<\/body>/is",$allHtml, $matches); */
            //$data['Html'] = $allHtml;
            $this->ajaxReturn($data, '操作成功!' , 1);
        }
    }

    /**
     * 获取默认配置类实例
     */
    function getTemplateConfigInstance(){
        $t = $this->getHomeTpl(); //获取Home模板数据
        $fileName = $t['pHomeConfig'];
        if( !file_exists($fileName)){
            $this->ajaxReturn(null, '模板配置文件不存在' , 0);
        }
        $lang = get_language_mark();
        import("@.Common.YdTemplateConfig");
        $tc = new YdTemplateConfig($fileName, $lang);
        if(!tc){
            $this->ajaxReturn(null, '读取模板配置文件失败' , 0);
        }
        return $tc;
    }

    /*
     * 保存样式设置，仅对就地修改有效
     */
    function saveContent(){
        header("Content-Type:text/html; charset=utf-8");
        $dataString = trim($_POST['DataString']);
        if(empty($dataString)){
            $this->ajaxReturn(null, '参数错误!' , 0);
        }
        $result = false;
        $content = $_POST['Content'];
        //格式：0数据模型, 1主键ID值, 2字段名称
        $data = explode(',', $dataString);
        $fieldName = $data[2];
		$data[1] = intval($data[1]);
        $type = strtolower($data[0]);
        if('channel' == $type){ //频道
            $map = 'ChannelName,ChannelSContent';
            if(false===stripos($map, $fieldName)){
                $this->ajaxReturn(null, '禁止修改' , 0);
            }
            $m = D('Admin/Channel');
            $where = "ChannelID={$data[1]}";
            $result = $m->where($where)->setField($fieldName, $content);
        }elseif('info' == $type){
            $map = 'InfoTitle,InfoSContent';
            if(false===stripos($map, $fieldName)){
                $this->ajaxReturn(null, '禁止修改' , 0);
            }
            $m = D('Admin/Info');
            $where = "InfoID={$data[1]}";
            $result = $m->where($where)->setField($fieldName, $content);
        }elseif('banner' == $type){ //幻灯片（允许修改所有字段）
            $m = D('Admin/Banner');
            $where = "BannerID={$data[1]}";
            $result = $m->where($where)->setField($fieldName, $content);
        }
        if($result !== false){
            $this->ajaxReturn(null, '保存成功!' , 1);
        }else{
            $this->ajaxReturn(null, '保存失败!' , 0);
        }
    }

    //====================组件编辑 开始====================

    /**
     * 获取所有组件
     */
    function getComponent(){
        header("Content-Type:text/html; charset=utf-8");
        $api = $this->_getApiInstance();
        $result = $api->getComponent();
        if(false !== $result){
            $this->ajaxReturn($result, "" , 1);
        }else{
            $error = $api->getLastError();
            $this->ajaxReturn(null,"获取组件失败！{$error}", 0);
        }
    }

    /**
     * 获取api对象
     */
    private function _getApiInstance(){
        $m = D('Admin/Config');
        $data = $m->getConfig('other'); //配置数据不从缓存中提取
        if(empty($data['DecorationAppID']) || empty($data['DecorationAppKey'])){
            $this->ajaxReturn(null, '服务未开通，请联系官方客服！', 0);
        }
        import("@.Common.YdApi");
        $api = new YdApi($data['DecorationAppID'], $data['DecorationAppKey']);
        return $api;
    }

    //===========================添加组件  开始===========================
    /*
     * 添加组件
     */
    function addComponent(){
        header("Content-Type:text/html; charset=utf-8");
        //1、获取组件数据
        $data = $this->_getComponentData();
        //2、插入配置文件
        $maxGroupID = $this->_addComponentConfig($data);
        //3、添加模板HTML代码
        $this->_addComponentHtml($data, $maxGroupID);
        //4、动态获取最新HTML内容，会存在问题：1）动画不生效，2）不会显示虚框
        //$this->_getComponentHtml($data, $maxGroupID);
        if(!APP_DEBUG) YdCache::deleteHome();
        $this->ajaxReturn($data, '' , 1);
    }

    /**
     * 获取组件数据
     */
    private function _getComponentData(){
        if(empty($_POST['GroupID'])){
            $this->ajaxReturn(null, '分组ID不能为空', 0);
        }
        if(empty($_POST['ComponentClassKey'])){
            $this->ajaxReturn(null, '分类KEY不能为空', 0);
        }
        $GroupID = intval($_POST['GroupID']);
        $ComponentClassKey = $_POST['ComponentClassKey'];
        $api = $this->_getApiInstance();
        //1、获取当前组件的HTML和配置数据
        $data = $api->findComponent($ComponentClassKey, $GroupID);
        if(false===$data){
            $lastError = $api->getLastError();
            $this->ajaxReturn(null, "获取组件数据失败 {$lastError}", 0);
        }
        return $data;
    }

    /**
     *  添加组件配置
     */
    private function _addComponentConfig(&$data){
        //获取当前模板配置最大分组ID
        $tc = $this->getTemplateConfigInstance();
        $maxGroupID = $tc->getMaxGroupID();
        $result = $tc->addGroup($maxGroupID, $data['GroupName'], $data['Config']);
        if(false===$result){
            $this->ajaxReturn(null, '添加配置项失败', 0);
        }
        return $maxGroupID;
    }


    /**
     * 添加组件HTML代码
     */
    private function _addComponentHtml(&$data, $maxGroupID){
        //当前点击的区块的分组ID
        $CurrentGroupID = intval($_POST['CurrentGroupID']);
        $fileName = $this->_getOrderTemplateFile($CurrentGroupID);
        $this->_checkTemplateFile($fileName);
        if(empty($_POST['GroupID'])){
            $this->ajaxReturn(null, '分组ID不存在!' , 0);
        }
        $classKey = $_POST['ComponentClassKey'];
        $content = file_get_contents($fileName);
        $tag = "<!--区块{$CurrentGroupID} 开始-->";
        $pos = stripos($content, $tag);
        //页头组件只能插入在头部
        if($classKey=='head' || $classKey=='foot'){
            if(false ===$pos) $pos = 0;
        }else{
            //如果当前区块不存在，就在body前面插入
            if(false ===$pos) $pos = stripos($content, '<include file="Public:footer" />');
            if(false ===$pos) $pos = stripos($content, '</body>');
        }

        $html = str_ireplace($data['GroupID'], $maxGroupID, $data['ComponentHtml']);
        $content = substr_replace($content, $html, $pos, 0);
        $result = file_put_contents($fileName, $content);
        return $result;
    }

    /**
     * 获取组件最新的内容
     */
    private function _getComponentHtml(&$data, $maxGroupID){
        $url = $_POST['PageUrl'];
        $content = yd_curl_get($url);
        if(empty($content)){
            $this->ajaxReturn(null, '当前页面数据为空', 0);
        }
        $pattern = "<!--区块{$maxGroupID} 开始-->.*?<!--区块{$maxGroupID} 结束-->";
        $pattern = "~{$pattern}~is";
        $matches = array();
        $n = preg_match_all($pattern,$content, $matches);
        if(empty($n)){
            $this->ajaxReturn(null, "区块{$maxGroupID}不存在", 0);
        }
        $data['ComponentHtml'] = $matches[0][0];
    }
    //===========================添加组件  结束===========================

    /*
     * 删除组件
     */
    function deleteComponent(){
        header("Content-Type:text/html; charset=utf-8");
        $fileName = $this->_getOrderTemplateFile($_POST['GroupID']);
        $this->_checkTemplateFile($fileName);
        if(empty($_POST['GroupID'])){
            $this->ajaxReturn(null, '分组ID不存在!' , 0);
        }
        $content = file_get_contents($fileName);
        $GroupID= trim($_POST['GroupID']);
        if($GroupID < 5000){
            $this->ajaxReturn(null, "只能删除自定义组件！" , 0);
        }
        $startTag = "<!--区块{$GroupID} 开始-->";
        $endTag = "<!--区块{$GroupID} 结束-->";
        $startPos = stripos($content, $startTag);
        $endPos = stripos($content, $endTag);
        if(false ===$startPos || false === $endPos){
            $this->ajaxReturn(null, "当前区块[{$GroupID}]不存在！" , 0);
        }
        $tc = $this->getTemplateConfigInstance();
        $result = $tc->deleteGroup($GroupID);
        if($result){
            $newContent = substr($content, 0, $startPos);
            $newContent .= substr($content, $endPos+strlen($endTag));
            $result = file_put_contents($fileName, $newContent);
            if(!APP_DEBUG) YdCache::deleteHome();
            $this->ajaxReturn(null, "删除成功!" , 1);
        }else{
            $errorMsg = $tc->getLastError();
            $this->ajaxReturn(null, "删除失败!{$errorMsg}" , 0);
        }
    }

    /*
     * 保存排序
     */
    function orderComponent(){
        header("Content-Type:text/html; charset=utf-8");
        $fileName = $this->_getOrderTemplateFile($_POST['CurrentGroup']);
        $this->_checkTemplateFile($fileName);
        if(empty($_POST['TargetGroup'])){
            $this->ajaxReturn(null, '不能移动，目标分组ID不存在!' , 0);
        }
        $error = "";
        $result = $this->_orderContent($fileName, $error);
        if($result === true){
            if(!APP_DEBUG) YdCache::deleteHome();
            $this->ajaxReturn(null, "移动成功!" , 1);
        }else{
            $this->ajaxReturn(null, "移动失败!{$error}" , 0);
        }
    }

    /**
     * 检查模板文件
     */
    private function _checkTemplateFile($fileName){
        if(empty($fileName)){
            $this->ajaxReturn(null, '模板文件不存在!', 0);
        }
        $isWrite = yd_is_writable($fileName);
        if(!$isWrite){
            $this->ajaxReturn(null, '模板文件只读，没有权限修改！' , 0);
        }
    }

    /**
     * 获取当前key的内容
     */
    private function _orderContent($fileName, &$error){
        $content = file_get_contents($fileName);
        $CurrentContent = $this->_getCurrentContent($content, $error);
        if(empty($CurrentContent)){
            return false;
        }
        $TargetGroup = trim($_POST['TargetGroup']);
        //moveup：升序，movedown：降序
        if ($_POST['Order']=='moveup') {
            $tag = "<!--区块{$TargetGroup} 开始-->";
            $pos = stripos($content, $tag);
        }else{
            $tag = "<!--区块{$TargetGroup} 结束-->";
            $pos = stripos($content, $tag);
            if(false !== $pos )$pos += strlen($tag);
        }
        if(false === $pos){
            $error = "目标区块[{$TargetGroup}]不存在！";
            return false;
        }
        $content = substr_replace($content, $CurrentContent, $pos, 0);
        $result = file_put_contents($fileName, $content);
        if(false !== $result){
            return true;
        }else{
            return "";
        }
    }

    /**
     * 获取当前块的内容
     */
    private function _getCurrentContent(&$content, &$error){
        $CurrentGroup = trim($_POST['CurrentGroup']);
        $startTag = "<!--区块{$CurrentGroup} 开始-->";
        $endTag = "<!--区块{$CurrentGroup} 结束-->";
        $startPos = stripos($content, $startTag);
        $endPos = stripos($content, $endTag);
        if(false ===$startPos || false === $endPos){
            $error = "当前区块[{$CurrentGroup}]不存在！";
            return false;
        }
        $endPos += strlen($endTag);
        $length = $endPos - $startPos;
        $CurrentString = substr($content, $startPos, $length);
        if(empty($CurrentString)){
            $error = "当前区块[{$CurrentGroup}]为空！";
            return false;
        }
        $newContent = substr($content, 0, $startPos);
        $newContent .= substr($content, $endPos);
        $content = $newContent;
        //前后加上换行，便于对齐格式
        $CurrentString = $CurrentString;
        return $CurrentString;
    }

    /**
     * 获取待排序模板的文件路径
     * $CurrentGroupID：当前分组ID
     */
    private function _getOrderTemplateFile($CurrentGroupID){
        $ThemeName = C('HOME_DEFAULT_THEME');
        $Prefix = TMPL_PATH."Home/{$ThemeName}/";
        //PageUrl可能的值：
        //新闻页：http://cms9.a.com/index.php/news.html
        //首页：http://cms9.a.com/index.php，启用伪静态后是：http://cms9.a.com/
        $PageUrl = trim($_POST['PageUrl']);
        $name =  basename($PageUrl); //basename(""http://cms9.a.com/) 返回cms9.a.com
        //启用伪静态后，首页substr($PageUrl,-1)，返回/
        if('index.php' == strtolower($name) || empty($name) || '/'==substr($PageUrl,-1) ){ //首页
            $ComponentClassKey = $_POST['ComponentClassKey'];
            //header和foot组件只能插入头部和底部文件
            if($ComponentClassKey=='head'){
                $templateFile = "{$Prefix}Public/header.html";
                if(!file_exists($templateFile)) return false;
                return $templateFile;
            }elseif($ComponentClassKey=='foot'){
                $templateFile = "{$Prefix}Public/footer.html";
                if(!file_exists($templateFile)) return false;
                return $templateFile;
            }else{
                $templateFile = 'index.html';
            }
        }else{
            $temp = explode('.', $name); //去掉扩展名
            $m = D('Admin/Channel');
            $where['LanguageID'] = get_language_id();
            $where['Html'] = $temp[0];
            $templateFile = $m->where($where)->getField('IndexTemplate');
            $templateFile = trim($templateFile, '.html'); //guestbook好像没有html结尾
            $templateFile = "{$templateFile}.html";
        }
        $fileName = false;
        if(!empty($templateFile)){
            $list = array("Channel/{$templateFile}", "Public/header.html", "Public/footer.html");
            $keywords = "<!--区块{$CurrentGroupID} 开始-->";
            foreach($list as $v){
                $templateFile = "{$Prefix}{$v}";
                if(!file_exists($templateFile)) continue;
                $content = file_get_contents($templateFile);
                if(false !== stripos($content, $keywords)){
                    $fileName = $templateFile;
                    break;
                }
            }
        }
        return $fileName;
    }
    //====================组件编辑 结束====================

    /**
     * 获取自定义代码
     */
    function getCode(){
        header("Content-Type:text/html; charset=utf-8");
        $ThemeName = C('HOME_DEFAULT_THEME');
        $fileName = TMPL_PATH."Home/{$ThemeName}/Public/code.html";
        $content = '';
        if(file_exists($fileName)){
            $content = file_get_contents($fileName);
        }
        if(empty($content)){
            $content = "<style>
/*----------------------平板板式样式----------------------*/ 
@media screen and (min-width:641px) and (max-width:1200px) { 


}

/*----------------------手机板式样式----------------------*/
@media screen and (max-width:640px) {


}
</style>
  
<!--------------------------自定义脚本代码 开始------------------------>
<script  type=\"text/javascript\">
$(document).ready(function(){
  
});
</script>
<!--------------------------自定义脚本代码 结束------------------------>";
        }
        $this->ajaxReturn($content, '' , 1);
    }

    /**
     * 保存自定义代码
     */
    function saveCode(){
        header("Content-Type:text/html; charset=utf-8");
        $ThemeName = C('HOME_DEFAULT_THEME');
        $fileName = TMPL_PATH."Home/{$ThemeName}/Public/code.html";
        $content =  stripslashes($_POST['Content']); //自定义代码
        $result = file_put_contents($fileName, $content);
        if(false !== $result){
            if(!APP_DEBUG) YdCache::deleteHome();
            $this->ajaxReturn(null, '保存成功' , 1);
        }else{
            $this->ajaxReturn(null, '保存失败' , 0);
        }
    }
}