<?php

/**
 * 多端小程序模板
 */
class TemplateModel extends Model{
    /**
     * 获取模板
     */
	function getTemplate($p=array()){
        $where = "";
        $this->order("IsDefault desc, TemplateOrder asc, TemplateID desc");
		$result = $this->where($where)->select();
        AddResDomain($result, 'TemplatePicture');
		return $result;
	}

    /**
     * 查看模板
     */
	function findTemplate($TemplateID, $p = array() ){
		$where['TemplateID'] = intval($TemplateID);
		$result = $this->where($where)->find();
        //表示获取模板的所有页面
        if(isset($p['HasTemplatePage']) && $p['HasTemplatePage']==1){
           $m = D('Admin/TemplatePage');
           $params = array();
           $params['TemplateID'] = $TemplateID;
            $result['TemplatePages'] = $m->getTemplatePage($params);
        }
		return $result;
	}

    /**
     *  删除模板
     */
	function deleteTemplate($TemplateID){
	    if( !is_numeric($TemplateID) ) return false;
	    $where = "TemplateID={$TemplateID}";
		$result = $this->where($where)->delete();
		if($result>0){
		    //删除模板的同时还必须删除页面
            $m = D('Admin/TemplatePage');
            $result = $m->where($where)->delete();
        }
		return $result;
	}

    /**
     * 设为默认模板
     */
    function setDefaultTemplate(int $TemplateID){
        $where = "TemplateID={$TemplateID}";
        $result = $this->where($where)->setField('IsDefault', 1);
        if(false !== $result){
            $where ="TemplateID!={$TemplateID}";
            $result = $this->where($where)->setField('IsDefault', 0);
        }
        return $result;
    }

    /**
     * 模板备份
     */
    function backupTemplate($TemplateID){
        $TemplateID = intval($TemplateID);
        $where ="TemplateID={$TemplateID}";
        $this->field('TemplateID,IsDefault,CreatTime', true);
        $data = $this->where($where)->find();
        if(empty($data)) return false;
        $data['IsDefault'] = 0; //备份的模板一定不是当前默认
        $data['TemplateName']  = "{$data['TemplateName']}_备份";
        $data['CreateTime'] = date("Y-m-d H:i:s");
        $data['IsEnable'] = 1;
        $this->startTrans();
        $result  = $this->add($data);
        if($result > 0){
            $NewTemplateID = $result;
            //备份模板页面
            $m = D('Admin/TemplatePage');
            $m->field('TemplatePageID', true);
            $result = $m->where($where)->select();
            if(!empty($result)){
                //备份模板，必须修改所属模板ID
                foreach($result as $k=>$v){
                    $result[$k]['TemplateID'] = $NewTemplateID;
                }
                $result = $m->addAll($result);
            }
        }
        if(false != $result){
            $this->commit();
        }else{
            $this->rollback();
        }
        return $result;
    }

    /**
     * 修改模板
     */
    function modifyTemplate($data){
        $TemplateID = $data['TemplateID'];
        if( !is_numeric($TemplateID) ) return false;
        $where = "TemplateID={$TemplateID}";
        $dataToUpdate = array();
        $dataToUpdate['TemplateName'] = $data['TemplateName'];
        $dataToUpdate['TemplatePicture'] = app_remove_domain($data['TemplatePicture']);
        $dataToUpdate['ThemeColor'] = $data['ThemeColor'];
        $dataToUpdate['TemplateOrder'] = $data['TemplateOrder'];
        $result = $this->where($where)->setField($dataToUpdate);
        return $result;
    }

    /**
     * 获取默认模板ID
     */
    function getDefaultTemplateID(){
        $where = "IsDefault=1";
        $id = $this->where($where)->getField('TemplateID');
        return $id;
    }

    /**
     * 创建一个空模板
     */
    function createTemplate($data){
        $dataToAdd = array();
        $dataToAdd['TemplateName'] = $data['TemplateName'];
        $dataToAdd['IsDefault'] = 0; //备份的模板一定不是当前默认
        $dataToAdd['CreateTime'] = date("Y-m-d H:i:s");
        $dataToAdd['TemplateOrder'] = 99;
        $dataToAdd['TemplatePicture'] = ''; //默认为空
        $dataToAdd['IsEnable'] = 1;
        $this->startTrans();
        $result = $this->add($dataToAdd);
        if($result > 0){
            $TemplateID = $result;
            $m = D('Admin/TemplatePage');
            $result = $m->addDefaultTemplatePage($TemplateID);
        }
        if(false !== $result){
            $dataToAdd['TemplateID'] = $TemplateID;
            $result = $dataToAdd;
            $this->commit();
        }else{
            $this->rollback();
        }
        return $result;
    }

}
